/////////////////////////////////////////////////////////////////////////////////////////////
//Parametrische analytische Flächen
//3D-Darstellung verschiedener Gittern und Flächen (Tasten 1,2,...9,0,ß,?,§,$) mit Maus Ansicht von allen Seiten  
//Zusatzparameter a
//Wahl Farbkodierung: Tasten u,i,o,p
//Wahl Farbverlauf: Tasten y,z
//Wahl zoomen/nicht zoomen: Taste #
//Rein/raus-Zoomen: Zuerst mit Taste # "zoomen" einstellen. Dann Tasten +/-
//Anzahl Gitterpunkte vergrößern/verkleinern ohne zoomen: 
//Zuerst mit Taste # "nicht zoomen" einstellen.Dann Tasten +/-
//Bei der Einstellung "zoomen" wird Anzahl der Gitterpunkte ebenfalls verändert!
////////////////////////////////////////////////////////////////////////////////////////////////
import nervoussystem.obj.*;//Export als obj-Datei

float x,y; //EbeneneKoordinaten
float zW; //Zwischenwert
float z; //Höhe
float r,alpha;//Radius und Winkel
float r3D; //Radius im Raum
float R; //Radius Parameter

int anzahlX = 100;//Anzahl Pixel in x-Richtung
float xMin =      0;
float xMax =   2*PI;
float xMitte;

int anzahlY = 100;//Anzahl Pixel in y-Richtung
float yMin =       0;
float yMax =      PI;
float yMitte;

float xKontrolle =0; //für Surface 14

float zMin = 100;
float zMax =-100;
float rMax =   0;
float rMin = 100;
float r3DMax = 0;
float r3DMin = 100;
float scaleFaktor = 30;

PVector[][] punkte ;//Punkte im Raum mit Pixelnummer

float[][] radius;
float a; //Parameter zum verändern der Funktion

float u2,u3,u4,u5,u6,u7;//Hilfs-Paramter
float T,T1,T2,T3,T4,T5;//für Zwischenergebnisse
float Tx,Ty,Tz;//für Zwischenergebnisse
float L,B,D,W; //Ei-Parameter Surface 14
float geoRotX = 0;
float geoRotY = 0;//PI/2;

float f=0;//hue-Wert
float F=0; //hue-Wert auf 0...255 gemappt
float G=0; //hue-Wert auf 0...1 gemappt
boolean gitter;
boolean originalDefBer=false;//-10<x,y<10 -
boolean teilBild = false;
boolean aufzeichnen=false;
boolean zoomen=false;
boolean lichtV,lichtH,lichtR,lichtL,lichtO,lichtU;
boolean hintergrundWeiss;
boolean KAZeichnen = false;//Koordinatenachsen nicht zeichnen
int wahlFunktion;
int wahlFarbKodierung;
int wahlFarbVerlauf;
color farbeVon;
color farbeBis;
color farbe;
///////////////////////////////////////////////////////////////////////////////////////////
void setup() {
  size(800, 800, P3D);
  smooth(8);
  colorMode(HSB);
  lichtH=true; lichtV=false; lichtO=true; lichtU=true; lichtR=true; lichtL=true;
  gitter = true;
  punkte = new PVector[anzahlX+1][anzahlY+2];
 hintergrundWeiss = true;
  radius = new float[anzahlX+1][anzahlY+2];
  wahlFunktion =1;
  wahlFarbKodierung = 1;
  wahlFarbVerlauf = 1;
  a=1;//für surface 4 
  L= 8.5;B=5.2 ;D=4.3; W=0.7; //Ei-Parameter Surface 14
 
  raumPunkteBerechnen();
 
}

/////////////////////////////////////////////////////////////////////////////////////////////
void draw() {
  if(hintergrundWeiss)background(255);
  else background(0);
  if(gitter){    
    if( wahlFarbKodierung == 3) strokeWeight(1/scaleFaktor);//ohne Farbe
    else strokeWeight(1/(3*scaleFaktor));  
  }else{ 
    noStroke();
  }
   if(aufzeichnen) {
    //export an obj file
    MeshExport obJ = (MeshExport) createGraphics(400,400,"nervoussystem.obj.OBJExport","colored.obj");
    obJ.setColor(true);
    obJ.beginDraw();
    gridZeichnen(obJ);
    obJ.endDraw();
    obJ.dispose();
    aufzeichnen = false;
  }
  //Objekt in Bildmitte
  translate(width*0.5, height*0.5, 0); 
  scale(scaleFaktor);
  
  if (mousePressed){ 
      geoRotX = map(mouseY,0,height,0,-2*PI);//Rotation um die x-Achse
      geoRotY = map(mouseX,0,width,0,-2*PI); //Rotation um die y-Achse
      
  }
 
  // rotiere um x-Achse je nach Höhe der Maus (linker Button)  
  rotateX(geoRotX); 
  // rotiere um y-Achse je nach seitlicher Koordinate der Maus  
  rotateY(geoRotY);
   //KoordinatenAchsen zeichnen
  if(KAZeichnen){
    strokeWeight(0.1);
    stroke(0,255,255);line(0,0,0,200,0,0);//rot: x-Achse
    stroke(80,255,255);line(0,0,0,0,200,0);//grün: y-Achse
    stroke(160,255,255);line(0,0,0,0,0,200);//blau: z-Achse
    strokeWeight(0);
  }
  gridZeichnen(this.g); 
  
}
/////////////////////////////////////////////////////////////////////////////////////////////
void raumPunkteBerechnen(){
 
  for (int ix = 0; ix <= anzahlX; ix++) {    
     for (int iy = 0; iy <= anzahlY+1; iy++) {
         x = map(ix, 0, anzahlX, xMin, xMax);
         y = map(iy, 0, anzahlY, yMin, yMax);//Pixel(ix,iy) auf eKoordinatensystem (x,y) abbilden
       
         //println(xMin,yMin,xMax,yMax);
         punkte[ix][iy] = new PVector();         
         //alpha = PI+atan2(y,x);
         switch(wahlFunktion){
         case 1://Sphäre 
               Tx = a*8*cos(x)*sin(y);
               Ty = 8*sin(x)*sin(y);
               Tz = 8*cos(y);                                       
              break;
              
          case 2://Clover Knot (Trefoil)     
               T=2+0.6*cos(x/2);
               Tx = 3*(T*cos(x/3)+0.6*cos(x/3)*cos(y-PI));
               Ty = 3*(T*sin(x/3)+0.6*sin(x/3)*cos(y-PI));
               Tz = 3*(0.6+sin(x/2)+0.6*a*sin(y-PI));        
              break;  
              
          case 3://Cross Cap    
               Tx = 8*cos(x)*sin(2*y);
               Ty = 8*sin(x)*sin(2*y);
               Tz = 8*(sq(cos(y))-a*sq(cos(x))*sq(sin(y)));
              break; 
              
          case 4://Immersion der kleinschen Flasche            
               Tx =1.5*(2+3*(cos(x/2)*sin(y)-sin(x/2)*sin(2*y)))*cos(x) ;
               Ty =1.5*(2+3*(cos(x/2)*sin(y)-sin(x/2)*sin(2*y)))*sin(x) ;               
               Tz =1.5*3*a*(sin(x/2)*sin(y)+cos(x/2)*sin(2*y));
             break;    
               
          case 5://Immersion kleinschen Flasche
               u2=sq(cos(x));u3=u2*cos(x);
               u4=sq(u2);u5=u4*cos(x);
               u6=u5*cos(x);u7=u6*cos(x);
               T1= 3*cos(y)-30*sin(x)+90*u4*sin(x);
               T2= 60*u6*sin(x)+5*cos(x)*cos(y)*sin(x);
               T3=3*cos(y)-3*u2*cos(y)-48*u4*cos(y)+48*u6*cos(y);
               T4=60*sin(x)+5*cos(x)*cos(y)*sin(x)-5*u3*cos(y)*sin(x);
               T5=80*u5*cos(y)*sin(x)+80*u7*cos(y)*sin(x);
               Tx =-0.64*cos(x)*(T1-T2); 
               Ty =-10-0.28*sin(x)*(T3-T4-T5);          
               Tz =0.64*a*(3+5*cos(x)*sin(x))*sin(y);                             
               break; 
               
          case 6://Verdrehter Torus
               Tx = 4*(1.5 * cos(x) * (1 + sin(y) * cos(x) - sin(2*y) * sin(x) / 2));
               Ty = 4*(1.5 * sin(x) * (1 + sin(y) * cos(x) - sin(2*y) * sin(x) / 2)) ;
               Tz = 4*(1.5 * sin(x) * sin(y) +a*cos(x) * sin(2*y) / 2);              
              break;
              
          case 7://Lemniscate
               T1 = cos(y)/(1+sq(sin(y))); T2 = cos(y)/(1+sq(sin(y)))*sin(y);
               Tx = 5*(1.5+T1*cos(5*x/2)-T2*sin(5*x/2))*cos(x);
               Ty = 5*(1.5+T1*cos(5*x/2)-T2*sin(5*x/2))*sin(x);
               Tz = 5*(T1*sin(5*x/2)+a*T2*cos(5*x/2));
              break;
       
         case 8://Torus
               Tx = 1.5*(5+2*cos(x))*cos(y);
               Ty = 1.5*(5+2*cos(x))*sin(y);
               Tz = 1.5*a*2*sin(x);           
              break;
              
         case 9://Jeener-Klein entartet
               T = 0.5*cos(2*x+PI/3)+3;
               Tx = 3*a*(2*cos(x));
               Ty = 3*T*sin(y);
               Tz = -3*T*cos(y);           
              break;
       
         case 0://JeenerKlein
               T = 0.75*cos(3*x+PI/4)+1;
               Tx = 3*(2*cos(x)+cos(2*x)-T*sin(x/2)*cos(y));
               Ty = 3*a*T*sin(y);
               Tz = 3*(2*sin(x)-sin(2*x)-T*cos(x/2)*cos(y));           
              break;
              
        case 10://Schnecke
               T = exp(x/(6*PI));
               Tx = 2.5*(2*(1-T)*cos(x)*cos(y/2)*cos(y/2));
               Ty = 2.5*a*(1-exp(x/(3*PI))-sin(y)+T*sin(y))+10;
               Tz = 2.5*(2*(-1+T)*sin(x)*cos(0.5*y)*cos(0.5*y));           
              break;
              
        case 11://Neovius' Surface Variante
               Tx = x*cos(x);
               Ty = y*sin(x);
               Tz = acos(-3*(cos(a*x)+cos(a*y))/(3+4*cos(a*x)*cos(a*y)));    
              break;
         
         case 12://Quadruple Point Cyclide
               Tx =  30*cos(y)*sq(sin(y))*sin(y)*sin(2*a*x)*cos(a*x);
               Ty =  30*cos(y)*sq(sin(y))*sin(y)*sin(2*a*x)*sin(a*x);;
               Tz = -30*cos(y)*sq(sin(y))*sin(2*x);           
              break;
        
         case 13://Heart
               Tx =  0.5*sin(y)*(15*sin(x)-4*sin(3*x));
               Ty =  2*cos(y);
               Tz =  0.5*sin(y)*(15*cos(x)-5*cos(2*x)-2*cos(3*x)-cos(2*x));           
              break;  
              
           case 14://Egg Theory of Oomorphologie Valery Narushin
               T1 =  B/2*sqrt((sq(L)-4*sq(x))/(sq(L)+8*W*x+4*sq(W))); 
               T2 = (sqrt(5.5*sq(L)+11*L*sq(W))*(1.732*B*L-2*D*sqrt(sq(L)+2*W*L+4*sq(W))));
               T3 =  1.732*B*L*(sqrt(5.5*sq(L)+11*L*W+4*sq(W))-2*sqrt(sq(L)+2*W*L+4*sq(W)));
               T4 =  L*(sq(L)+8*W*x+4*sq(W));
               T5 =  (L-2*W)+sq(x)+(sq(L)+8*L*W-4*sq(W))*x+2*L*sq(W)+sq(L)*W+sq(L)*L;
               Tx =  2*T1*(1-T2/T3*(1-sqrt(T4/T5)))*sin(2*y); 
               Ty = -2*x;  
               Tz =  2*T1*(1-T2/T3*(1-sqrt(T4/T5)))*cos(2*y);  
              break;        
         }
           punkte[ix][iy].x = Tx;
           punkte[ix][iy].y = Ty;
           punkte[ix][iy].z = Tz;           
           r3D = sqrt(sq(punkte[ix][iy].x)+ sq(punkte[ix][iy].y)+sq(punkte[ix][iy].z));
           if(r3D>r3DMax) r3DMax = r3D;//Radius im Raum
           if(r3D<r3DMin) r3DMin = r3D; 
           radius[ix][iy]=sqrt(sq(punkte[ix][iy].x)+ sq(punkte[ix][iy].y));
           r= radius[ix][iy];//print(r+"   ");
           if(r>rMax) rMax = r;//maximaler Radius in der x-y-Ebene
           if(r<rMin) rMin = r; //println(rMin,rMax);
           if(punkte[ix][iy].z < zMin) zMin = punkte[ix][iy].z;
           if(punkte[ix][iy].z > zMax) zMax = punkte[ix][iy].z;//Höhenbereich bestimmen
     }   
  }
}
/////////////////////////////////////////////////////////////////////////////////////////////
void keyPressed(){//redundant angelegt, damit man die Grids einzeln anpassen kann
  if(key == 'm'){
     gitter=!gitter;
     standardWerteEinstellen();
  }  
  if(key == '1') {
     wahlFunktion = 1;
     a=1;
     originalDefBer = false;
     standardWerteEinstellen();    
  }
  if(key == '2') {
     wahlFunktion = 2;
     a=1;
     originalDefBer = false;
     standardWerteEinstellen();
  }
  if(key == '3') {
     wahlFunktion = 3;
     originalDefBer = false;
     standardWerteEinstellen();
  }
  if(key == '4') {
     wahlFunktion = 4;
     originalDefBer = false;
     a=1;
     standardWerteEinstellen();
   }
  if(key == '5') {
     wahlFunktion = 5;
     originalDefBer = false;
     a=1; 
     standardWerteEinstellen();
  }
  if(key == '6') {
     wahlFunktion = 6;
     originalDefBer = false;
     a=1;
     standardWerteEinstellen();
  } 
  if(key == '7') {
     wahlFunktion = 7;
     originalDefBer = false;
     a=1;
     standardWerteEinstellen();
  }
  if(key == '8') {
     wahlFunktion = 8;
     originalDefBer = false;
     a=1;
     standardWerteEinstellen();
  } 
  if(key == '9') {
     wahlFunktion = 9;
     originalDefBer = false;
     a=1;
     standardWerteEinstellen();
  } 
  if(key == '0') {
     wahlFunktion = 0;
     originalDefBer = false;
     a=1;
     standardWerteEinstellen();
  } 
  if(key == 'ß') {
     wahlFunktion = 10;
     originalDefBer = false;
     a=1;
     standardWerteEinstellen();
  } 
  if(key == '?') {
     wahlFunktion = 11;
     originalDefBer = false;
     a=1;
     standardWerteEinstellen();
  } 
  if(key == '§') {
     wahlFunktion = 12;
     originalDefBer = false;
     a=1;
     standardWerteEinstellen();
  } 
  if(key == '$') {
     wahlFunktion = 13;
     originalDefBer = false;
     //kein Parameter hier
     standardWerteEinstellen();
  } 
  if(key == '%') {
     wahlFunktion = 14;
     originalDefBer = false;   
     standardWerteEinstellen();
     println(xMax);
  } 
  
  if(key == 'u') wahlFarbKodierung =1;  
  if(key == 'i') wahlFarbKodierung =2;  
  if(key == 'o') wahlFarbKodierung =3;
  if(key == 'p') wahlFarbKodierung =4;
  if(key == 'y') wahlFarbVerlauf =1;  
  if(key == 'S') hintergrundWeiss = !hintergrundWeiss;
  if(key == 'l') {L=L-0.2;raumPunkteBerechnen();}
  if(key == 'L') {L=L+0.2;raumPunkteBerechnen();}
  if(key == 'b') {B=B-0.2;raumPunkteBerechnen();}
  if(key == 'B') {B=B+0.2;raumPunkteBerechnen();}
  if(key == 'd') {D=D-0.2;raumPunkteBerechnen();}
  if(key == 'D') {D=D+0.2;raumPunkteBerechnen();}
  if(key == 'w') {W=W-0.5;raumPunkteBerechnen();}
  if(key == 'W') {W=W+0.5;raumPunkteBerechnen();}
  if(key == 'z') {
    wahlFarbVerlauf =2;
     farbeVon = color(random(255),random(150,255),random(150,255));
     farbeBis = color(random(255),random(150,255),random(150,255));
     while(abs(hue(farbeBis)-hue(farbeVon))<100){
        farbeBis = color(random(255),random(150,255),random(150,255));
     }
     println("Verlaufsfarben zwischen: "+hue(farbeVon),hue(farbeBis));
  }   
  if(key == '+'){    
     if(zoomen) scaleFaktor = 1.2*scaleFaktor;  //Falls gezoomt werden soll  
     anzahlX = round(1.2*(float)anzahlX);
     anzahlY = round(1.2*(float)anzahlY);println("Anzahl +: "+scaleFaktor,anzahlX,anzahlY);
     punkte = new PVector[anzahlX+1][anzahlY+2];   
     radius = new float[anzahlX+1][anzahlY+2];
     raumPunkteBerechnen();    
  }
  if(key == '-'){
     if(zoomen) scaleFaktor = 1/1.2*scaleFaktor;
     anzahlX = round(1/1.2*(float)anzahlX);
     anzahlY = round(1/1.2*(float)anzahlY);println("Anzahl -: "+scaleFaktor,anzahlX,anzahlY);
     punkte = new PVector[anzahlX+1][anzahlY+2];
     radius = new float[anzahlX+1][anzahlY+2];
     raumPunkteBerechnen();    
  } 
  if(key == '#'){//Achtung: !zoomen und Tasten '+' bzw '-' bewirkt lediglich ...
     zoomen=!zoomen;//... eine Vergrößerung/Verkleinerung von anzahlX bzw anzahlY
     if(zoomen) println("Zoomen");
     else println("Gitterpunkte vergrößern/verkleinern");
  }
  if(key == 't'){
     teilBild = !teilBild;    
     standardWerteEinstellen();
     raumPunkteBerechnen();     
  }
  if(key =='a'){
     a = a+0.5;
     standardWerteEinstellen();
     raumPunkteBerechnen();   
  }
  if(key =='A'){
     a = a-0.5;
     standardWerteEinstellen();
     raumPunkteBerechnen();   
  }
  if(key=='.'){
     aufzeichnen=true;//export in an object-file
  }
  if(key=='s'){
    save("bild.png");
  }
  if(key =='k'){
     KAZeichnen = !KAZeichnen;
     standardWerteEinstellen();
     raumPunkteBerechnen();   
  }
}
/////////////////////////////////////////////////////////////////////////////////////
void standardWerteEinstellen(){
     zMin = 100;
     zMax =-100;//Initialisierung 
     rMax = 0; r3DMax = 0;
     rMin = 100; r3DMin = 100;
     scaleFaktor = 30;
     if(gitter){
        anzahlX = 100; anzahlY=100;
     }else{
        anzahlX = 400; anzahlY=400;
     }
     punkte = new PVector[anzahlX+1][anzahlY+2];
     
     radius = new float[anzahlX+1][anzahlY+2];
     if(originalDefBer){
         xMin = -10; xMax = 10;
         yMin = -10; yMax = 10;
         if(teilBild){
           xMin =0;
         }
     }else{
       xMin = 0;
       yMin = 0;
       if(wahlFunktion==1){
         xMax = 2*PI;
         yMax = PI;
         if(teilBild){
           xMax =PI; 
         }
       }
       if(wahlFunktion==2){
         xMax = 12*PI;
         yMax = 2*PI;
         if(teilBild){
           yMin =PI; 
         }
       }
       if(wahlFunktion==3){
         xMax =  2*PI;
         yMax =  PI/2;
         if(teilBild){
           xMax = PI; 
         }
       }
       if(wahlFunktion==4){
         xMax =  2*PI;
         yMax =  2*PI;
         if(teilBild){
           xMax = 1.2*PI;
         }
       }
       if(wahlFunktion==5){
         xMax =  PI;
         yMax =  2*PI;
         if(teilBild){
           yMax =PI; 
         }
       }
       if(wahlFunktion==6){
         xMin=3.5;xMax = 10;
         yMin=3.5;yMax = 10;
         if(teilBild){
           xMin =6;  
         }       
       } 
       if(wahlFunktion==7){
         xMin=0;xMax = 2*PI;
         yMin=-PI/4;yMax =5* PI/4;
         if(teilBild){
           yMax=PI/4;  
         }       
       } 
       if(wahlFunktion==8 || wahlFunktion==9 || wahlFunktion==0){
         xMin=0;xMax = 2*PI;
         yMin=0;yMax = 2*PI;
         if(teilBild){
           yMax=PI;  
         }       
       }  
       if(wahlFunktion==10){
         xMax = 6*PI;
         yMax =2*PI;
         if(teilBild){
           yMax=PI;  
         }       
       } 
       if(wahlFunktion==11){
         xMin = -4*PI;xMax = 4*PI;
         yMin = -4*PI;yMax = 4*PI;
         if(teilBild){
           yMin=PI/2;  
         }       
       } 
       if(wahlFunktion==12){
         xMin = 0;xMax = PI/2;
         yMin = 0;yMax = 2*PI;
        // anzahlX = 30; anzahlY=30;
         if(teilBild){
           yMin=PI;  
         }       
       } 
       if(wahlFunktion==13){
         xMin = 0;xMax = 2*PI;
         yMin = 0;yMax = PI;
         anzahlX = 30; anzahlY=30;
         if(teilBild){
           yMin=PI/2;  
         }   
       }
       if(wahlFunktion==14){
         xMin = -4.25;xMax = 4.25;
         yMin = 0;yMax =   PI;
         if(gitter){anzahlX = 100; anzahlY=100;}
         if(teilBild){
           yMax=PI/2;
         }       
       }         
     } 
     //xMitte=(xMax+xMin)/2; yMitte =(yMax+yMin)/2;//println(yMitte,yMin,yMax);
     raumPunkteBerechnen();
}
/////////////////////////////////////////////////////////////////////////////////////////////
void gridZeichnen(PGraphics pg) {
  
    if(!gitter) { 
      noStroke();     
      if(lichtV) directionalLight(0, 0, 255, 0, 0, -1);
      if(lichtH) directionalLight(0, 0, 255, 0, 0,  1); 
      if(lichtR) directionalLight(0, 0, 255,-1, 0,  0); 
      if(lichtL) directionalLight(0, 0, 255, 1, 0,  0); 
      if(lichtO) directionalLight(0, 0, 255, 0,-1,  0); 
      if(lichtU) directionalLight(0, 0, 255, 0, 1,  0); 
    }else{stroke(0);}
    
    for (int iy = 0; iy < anzahlY+1; iy++) {    
      pg.beginShape(QUAD_STRIP);  
      for (int ix = 0; ix < anzahlX+1; ix++) {
              
          quadsFaerben(ix,iy); 
          pg.vertex(  punkte[ix][iy].x ,   punkte[ix][iy].y ,   punkte[ix][iy].z );  
          pg.vertex(punkte[ix][iy+1].x , punkte[ix][iy+1].y , punkte[ix][iy+1].z );         
     
      }
      pg.endShape(); 
    } 
    
    if(wahlFunktion ==11){
      for (int iy = 0; iy < anzahlY+1; iy++) {    
        pg.beginShape(QUAD_STRIP);  
        for (int ix = 0; ix < anzahlX+1; ix++) {
                
            quadsFaerben(ix,iy); 
            pg.vertex(  punkte[ix][iy].x ,   punkte[ix][iy].y ,   -punkte[ix][iy].z );  
            pg.vertex(punkte[ix][iy+1].x , punkte[ix][iy+1].y , -punkte[ix][iy+1].z );         
         
        }
        pg.endShape(); 
      } 
    }  
}
//////////////////////////////////////////////////////////////////////////////////////////////
void quadsFaerben(int x, int y){
 
  int ix =x; int iy =y;
  switch(wahlFarbKodierung){
           case 1://x-y-Radius abhängig
              f = radius[ix][iy];//print(f,r+"   ");
              F = map(f,rMin,rMax,0,255);//if(70<F && F<80)print(F,rMin,rMax+"  ");
              G = map(f,rMin,rMax,0,1); //if(70<F && F<80)println(f,F,rMax);
              if(wahlFarbVerlauf == 1) fill(F,255,255);
              if(wahlFarbVerlauf == 2){
                  farbe = lerpColor(farbeVon,farbeBis,G);///println(F,F*0.0039);
                  fill(farbe);
              }
              break;
           case 2://Höhenabhängig
              f = punkte[ix][iy].z;//Höhe
              F = map(f,zMin,zMax,0,255);// if(F>120)print(F,zMin,zMax+"     ");
              if(wahlFarbVerlauf == 1)fill(F,255,255);
              if(wahlFarbVerlauf == 2){
                  G = map(f,zMin,zMax,0,1); //if(G>0.8)print(G+" ");
                  farbe = lerpColor(farbeVon,farbeBis,G);//println(hue(farbe),G);
                  fill(farbe);
              }
              break;     
           case 3://weiß
              fill(0,0,255);
              break;
          case 4: //Winkelabhängig       
              f =255*(180+degrees(atan2(punkte[ix][iy].y,punkte[ix][iy].x)))/360; //auf 0-255 gemappt  
              fill(f,255,255);
              break;
         case 5: //x-y-z Radius abhängig
              f=  sqrt(sq(punkte[ix][iy].x)+sq(punkte[ix][iy].y)+sq(punkte[ix][iy].z));
              F = map(f,r3DMin,r3DMax,0,255); //if(F<130)print(F+" ");
              G = map(f,r3DMin,r3DMax,0,1);//println(farbFaktor,f,F);
              if(wahlFarbVerlauf == 1) fill(F,255,255);
              if(wahlFarbVerlauf == 2){
                  farbe = lerpColor(farbeVon,farbeBis,G);///println(F,F*0.0039);
                  fill(farbe);
              }
      }
}
